<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/celnavmesh.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/celnavmesh.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2010 by Leonardo Rodrigo Domingues</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_NAVMESHAPI__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_NAVMESHAPI__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/list_8h.html">csutil/list.h</a>&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/poly3d_8h.html">csgeom/poly3d.h</a>&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>;
<a name="l00028"></a>00028 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOBB.html">csOBB</a>;
<a name="l00029"></a>00029 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>;
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structcsSimpleRenderMesh.html">csSimpleRenderMesh</a>;
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>;
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00039"></a><a class="code" href="structiCelNavMeshParams.html">00039</a> <span class="keyword">struct </span><a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00040"></a>00040 {
<a name="l00046"></a>00046   <span class="keyword">virtual</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* <a class="code" href="structiCelNavMeshParams.html#a1af68f28bdf28f20ebdaee3ae3191a98" title="Create a new object with the same instance variable&#39;s values as this one&#39;s.">Clone</a> () <span class="keyword">const</span> = 0;
<a name="l00047"></a>00047 
<a name="l00049"></a>00049   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a58010a9365c205fe3e3779f6574c7878" title="Set suggested values, given the agent parameters values.">SetSuggestedValues</a> (<span class="keywordtype">float</span> agentHeight, <span class="keywordtype">float</span> agentRadius, <span class="keywordtype">float</span> agentMaxSlopeAngle) = 0;
<a name="l00050"></a>00050 
<a name="l00052"></a>00052   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a754b3c5b4cf5b821ace947cb96d81cf1" title="Get agent height.">GetAgentHeight</a> () <span class="keyword">const</span> = 0;
<a name="l00054"></a>00054   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a4b83ae584a09bb211acac0ea86dbd2a8" title="Set agent height.">SetAgentHeight</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> height) = 0;
<a name="l00055"></a>00055 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#ad9f2a84c17b3a6854fe56c7f9eb9c1c2" title="Get agent radius.">GetAgentRadius</a> () <span class="keyword">const</span> = 0;
<a name="l00059"></a>00059   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#ad8696024185f4df95ed91851a1711e0d" title="Set agent radius.">SetAgentRadius</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> radius) = 0;
<a name="l00060"></a>00060 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a83fcac9a4b4c814c018ba372bda2c6d2" title="Get agent maximum walkable slope angle (in degrees)">GetAgentMaxSlopeAngle</a> () <span class="keyword">const</span> = 0;
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#aea35d38a8e35a9eb5c3fc975ab93a968" title="Set agent maximum walkable slope angle (in degrees)">SetAgentMaxSlopeAngle</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> angle) = 0;
<a name="l00065"></a>00065 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a4fd16c304963b49af28b7ee00cd2dc8d" title="Get agent max climb.">GetAgentMaxClimb</a> () <span class="keyword">const</span> = 0;
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a541e7dd6d56a8e9412d6e838ade73f59" title="Set agent max climb.">SetAgentMaxClimb</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> maxClimb) = 0;
<a name="l00070"></a>00070 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#acc591491bb34e79c6662517ad5ed7fff" title="Get cell size.">GetCellSize</a> () <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a947751a88f4c0d7567b8f2ae76f59186" title="Set cell size.">SetCellSize</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> size) = 0;
<a name="l00075"></a>00075 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#aa2f52b19396d8ed0fe3aa79559b5b0bd" title="Get cell height.">GetCellHeight</a> () <span class="keyword">const</span> = 0;
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a22d8b5b14e2d5043571e473bcae26ee8" title="Set cell height.">SetCellHeight</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> height) = 0;
<a name="l00080"></a>00080 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a2e1cfdad666c5915343ae13e5bafd60a" title="Get maximum distance error from contour to cells.">GetMaxSimplificationError</a> () <span class="keyword">const</span> = 0;
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a959f0402ac290e42167f39564728d095" title="Set maximum distance error from contour to cells.">SetMaxSimplificationError</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> error) = 0;
<a name="l00085"></a>00085 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a31060ad9b8027c144397384d3a73de57" title="Get detail mesh sample spacing.">GetDetailSampleDist</a> () <span class="keyword">const</span> = 0;
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a85358c599aac106cb155e9bf655cf55e" title="Set detail mesh sample spacing.">SetDetailSampleDist</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> dist) = 0;
<a name="l00090"></a>00090 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshParams.html#a51dbf24fba9dee5ed0005fbbcb318d27" title="Get detail mesh simplification max sample error.">GetDetailSampleMaxError</a> () <span class="keyword">const</span> = 0;
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a663d66c7c6e96ff7909e9d0be11a3111" title="Set detail mesh simplification max sample error.">SetDetailSampleMaxError</a> (<span class="keyword">const</span> <span class="keywordtype">float</span> error) = 0;
<a name="l00095"></a>00095   
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#a37ff88785e6c94921da505895ef8b1c5" title="Get maximum contour edge length.">GetMaxEdgeLength</a> () <span class="keyword">const</span> = 0;
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a5d4facc510cc98b2dc0e03ab692fd306" title="Set maximum contour edge length.">SetMaxEdgeLength</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> length) = 0;
<a name="l00100"></a>00100 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#a4f5a40cb600152a3c6ee28f18c8ff4ae" title="Get minimum regions size (smaller regions will be deleted)">GetMinRegionSize</a> () <span class="keyword">const</span> = 0;
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#acb7e333d31b6e7912f7708fa7b5373c6" title="Set minimum regions size (smaller regions will be deleted)">SetMinRegionSize</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> size) = 0;
<a name="l00105"></a>00105 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#a25314901847a3a0bdb091fc2f7fc95e9" title="Get minimum regions size (smaller regions will be merged)">GetMergeRegionSize</a> () <span class="keyword">const</span> = 0;
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#abb0814b3b81b66127b0ec358c7149d67" title="Set minimum regions size (smaller regions will be merged)">SetMergeRegionSize</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> size) = 0;
<a name="l00110"></a>00110 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#ab0dd269061d2300d35274d4c768d0988" title="Get max number of vertices per polygon.">GetMaxVertsPerPoly</a> () <span class="keyword">const</span> = 0;
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a0f5932ad942d76fed8454b7afd55bc79" title="Set max number of vertices per polygon.">SetMaxVertsPerPoly</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> maxVerts) = 0;
<a name="l00115"></a>00115 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#ac00cec6af382156186c7f2a9faf16be4" title="Get tile size (Width and Height of a tile)">GetTileSize</a> () <span class="keyword">const</span> = 0;
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a6766e98c8e47e14a5c7a6be684cbd3b9" title="Set tile size (Width and Height of a tile)">SetTileSize</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> size) = 0;
<a name="l00120"></a>00120 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshParams.html#a96f47b09ac865b319d4662f7f37c6a4d" title="Get border size.">GetBorderSize</a> () <span class="keyword">const</span> = 0;
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a19ca44dbc16ed12f8a8254d6e8ca3a02" title="Set border size.">SetBorderSize</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> size) = 0;
<a name="l00125"></a>00125 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> <a class="code" href="structiCelNavMeshParams.html#ad1e10d09eea2d168ff449365b9143ed1" title="Set the size of the polygon search bounding box.">GetPolygonSearchBox</a> () <span class="keyword">const</span> = 0;
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshParams.html#a98a6caf18da8fc1cebd9d72416c40c60" title="Get the size of the polygon search bounding box.">SetPolygonSearchBox</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> box) = 0;
<a name="l00130"></a>00130 };
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00137"></a><a class="code" href="structiCelNavMeshPath.html">00137</a> <span class="keyword">struct </span><a class="code" href="structiCelNavMeshPath.html" title="Path between two points which lay in the same Sector.">iCelNavMeshPath</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139   SCF_INTERFACE (<a class="code" href="structiCelNavMeshPath.html" title="Path between two points which lay in the same Sector.">iCelNavMeshPath</a>, 1, 0, 0);
<a name="l00140"></a>00140 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="code" href="structiCelNavMeshPath.html#ab9d42a6717c5ba4952d38be1d4bf0c38" title="Get this path&#39;s sector.">GetSector</a> () <span class="keyword">const</span> = 0;
<a name="l00143"></a>00143 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#abd62b0b4006329d511951c1a60b47d56" title="Get current node from the navigation path.">Current</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vector) <span class="keyword">const</span> = 0;
<a name="l00146"></a>00146 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#a3a1a2d54acf73a12179323b2e4a50738" title="Get next node from the navigation path.">Next</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vector) = 0;
<a name="l00149"></a>00149 
<a name="l00151"></a>00151   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#a08f0e56ebb9932a4c43f0571fff9c840" title="Get previous node from the navigation path.">Previous</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vector) = 0;
<a name="l00152"></a>00152 
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#a9ad52f4127d6da755d4ef37eaf2ea122" title="Get first node from the navigation path.">GetFirst</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vector) <span class="keyword">const</span> = 0;
<a name="l00155"></a>00155 
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#a1b18429c7006a10a15bf8162e358cce9" title="Get last node from the navigation path.">GetLast</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; vector) <span class="keyword">const</span> = 0;
<a name="l00158"></a>00158 
<a name="l00160"></a>00160   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMeshPath.html#a3169df6cb147959ce634f42ec413e841" title="Check if the navigation mesh has nodes after the current one.">HasNext</a> () <span class="keyword">const</span> = 0;
<a name="l00161"></a>00161 
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMeshPath.html#a6c7001480b8f410c469465192b1e41b5" title="Check if the navigation mesh has nodes before the current one.">HasPrevious</a> () <span class="keyword">const</span> = 0;
<a name="l00164"></a>00164 
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#af2e3dbbbbe1f955ca49d18823d8f722d" title="Invert the navigation path.">Invert</a> () = 0;
<a name="l00167"></a>00167 
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#ae69523b610507e27207f2742c3c1ad92" title="Restart the navigation path.">Restart</a> () = 0;
<a name="l00170"></a>00170 
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#a67aee277211100b4c763358ac040a224" title="Add a new node at the end of the path.">AddNode</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> node) = 0;
<a name="l00173"></a>00173 
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshPath.html#aec5e31bcc6de18926b5cb9a77774c3ed" title="Add a new node in position pos.">InsertNode</a> (<span class="keywordtype">int</span> pos, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> node) = 0;
<a name="l00176"></a>00176 
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiCelNavMeshPath.html#adf7de8d93ba3a1c86f35c4890df66ea2" title="Calculate path length.">Length</a>() <span class="keyword">const</span> = 0;
<a name="l00179"></a>00179 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiCelNavMeshPath.html#a3afe0a3d76eb1d520e3aa2d3b0b5b522" title="Get the number of nodes in this path.">GetNodeCount</a> () <span class="keyword">const</span> = 0;
<a name="l00182"></a>00182 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelNavMeshPath.html#a228b4841290828555ce7f9f7e4d78eb4" title="Render path.">GetDebugMeshes</a> () <span class="keyword">const</span> = 0;
<a name="l00188"></a>00188 };
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="structiCelNavMesh.html">00195</a> <span class="keyword">struct </span><a class="code" href="structiCelNavMesh.html" title="Polygon mesh representing the navigable areas of a Sector.">iCelNavMesh</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   SCF_INTERFACE (<a class="code" href="structiCelNavMesh.html" title="Polygon mesh representing the navigable areas of a Sector.">iCelNavMesh</a>, 1, 0, 0);
<a name="l00198"></a>00198 
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <a class="code" href="structiCelNavMeshPath.html" title="Path between two points which lay in the same Sector.">iCelNavMeshPath</a>* <a class="code" href="structiCelNavMesh.html#ab49f6ec9d338a840328b113435ebb829" title="Find the shortest path between two points.">ShortestPath</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; from, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; goal, 
<a name="l00207"></a>00207                                          <span class="keywordtype">int</span> maxPathSize = 32) = 0;
<a name="l00208"></a>00208 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMesh.html#a758874a34e2103a4512a9c1e461aa6a2" title="Update the tiles of the navigation mesh that intersect with an axis aligned bounding box...">Update</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>&amp; boundingBox) = 0;
<a name="l00215"></a>00215 
<a name="l00221"></a>00221   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMesh.html#a758874a34e2103a4512a9c1e461aa6a2" title="Update the tiles of the navigation mesh that intersect with an axis aligned bounding box...">Update</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOBB.html">csOBB</a>&amp; boundingBox) = 0;
<a name="l00222"></a>00222 
<a name="l00224"></a>00224   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="code" href="structiCelNavMesh.html#adc66323b7f2c96224f9f20ffb95b05e2" title="Get navigation mesh sector.">GetSector</a> () <span class="keyword">const</span> = 0;
<a name="l00225"></a>00225 
<a name="l00227"></a>00227   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMesh.html#ac187f3d7d4c3d468a834a5fd4d5ac711" title="Set navigation mesh sector.">SetSector</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00228"></a>00228 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* <a class="code" href="structiCelNavMesh.html#adc81b9daa5e169826447041c5566bf48" title="Get navigation mesh parameters.">GetParameters</a> () <span class="keyword">const</span> = 0;
<a name="l00231"></a>00231 
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a> <a class="code" href="structiCelNavMesh.html#ac8bb43d465f095480a69484b30c1b65d" title="Get navigation mesh bounding box.">GetBoundingBox</a>() <span class="keyword">const</span> = 0;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// obtain a list of polygons overlapping a box</span>
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;csPoly3D&gt;</a> QueryPolygons(<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>&amp; box) <span class="keyword">const</span> = 0;
<a name="l00237"></a>00237 
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMesh.html#afa9fad1efa99c9ad8e477b7a76f8d6f4" title="Save to file.">SaveToFile</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>* file) <span class="keyword">const</span> = 0;
<a name="l00240"></a>00240 
<a name="l00245"></a>00245   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelNavMesh.html#a85e53939fcd5a1ed9bf7be96a5ec0334" title="Render navigation mesh.">GetDebugMeshes</a> () <span class="keyword">const</span> = 0;
<a name="l00246"></a>00246 
<a name="l00251"></a>00251   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelNavMesh.html#ad8c8e10cd66534fcad8977f9625c4688" title="Render proxy agent.">GetAgentDebugMeshes</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos) <span class="keyword">const</span> = 0;
<a name="l00252"></a>00252 
<a name="l00257"></a>00257   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsList.html">csList&lt;csSimpleRenderMesh&gt;</a>* <a class="code" href="structiCelNavMesh.html#ad8c8e10cd66534fcad8977f9625c4688" title="Render proxy agent.">GetAgentDebugMeshes</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos, <span class="keywordtype">int</span> red, <span class="keywordtype">int</span> green, 
<a name="l00258"></a>00258                                                            <span class="keywordtype">int</span> blue, <span class="keywordtype">int</span> alpha) <span class="keyword">const</span> = 0;
<a name="l00259"></a>00259 };
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00266"></a><a class="code" href="structiCelNavMeshBuilder.html">00266</a> <span class="keyword">struct </span><a class="code" href="structiCelNavMeshBuilder.html" title="Navigation mesh creator.">iCelNavMeshBuilder</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   SCF_INTERFACE (<a class="code" href="structiCelNavMeshBuilder.html" title="Navigation mesh creator.">iCelNavMeshBuilder</a>, 1, 0, 0);
<a name="l00269"></a>00269 
<a name="l00277"></a>00277   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelNavMeshBuilder.html#a33689960427ec82524362b5dd2725859" title="Set an iSector as the current working sector and loads it&#39;s triangles.">SetSector</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector) = 0;
<a name="l00278"></a>00278 
<a name="l00285"></a>00285   <a class="code" href="structiCelNavMeshBuilder.html#ae947c69377b3ab4a715b76a0567c5d9c" title="Build a navigation mesh from the triangles in a Sector, using current configuration.">THREADED_INTERFACE</a>(BuildNavMesh);
<a name="l00286"></a>00286 
<a name="l00292"></a>00292   <span class="keyword">virtual</span> <a class="code" href="structiCelNavMesh.html" title="Polygon mesh representing the navigable areas of a Sector.">iCelNavMesh</a>* <a class="code" href="structiCelNavMeshBuilder.html#ac0fef59d2f319f40b518cf40a107e6b2" title="Load a navigation mesh from a file.">LoadNavMesh</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>* file) = 0;
<a name="l00293"></a>00293 
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* <a class="code" href="structiCelNavMeshBuilder.html#a2d24d05047ffa9d337794243579e0f70" title="Get an object representation of the navigation mesh parameters.">GetNavMeshParams</a> () <span class="keyword">const</span> = 0;
<a name="l00299"></a>00299 
<a name="l00304"></a>00304   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelNavMeshBuilder.html#ad89e0128a9a53ac79532f989c17349e0" title="Set navigation mesh parameters.">SetNavMeshParams</a> (<span class="keyword">const</span> <a class="code" href="structiCelNavMeshParams.html" title="Wrapper for the parameters used to build the navigation mesh.">iCelNavMeshParams</a>* parameters) = 0;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* GetSector () <span class="keyword">const</span> = 0;
<a name="l00307"></a>00307  
<a name="l00308"></a>00308 };
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="preprocessor">#endif // __CEL_NAVMESHAPI__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
